#!/usr/bin/python

##################
# Modules Import #
##################
import random
import  sys
import  time
import  copy
import  os
import  datetime
import  subprocess
import usb.util
   
import usb.core
import usb.util
import sys
import pygame 
from pygame.locals import *
import threading
from threading import Thread
from array import array
import socket
import re
import string

version = "FCALLBOX PSU 2x30 V1.00"

# screen sizes

WINDOWWIDTH = 20 # width of the program's window, in pixels
WINDOWHEIGHT = 540 # height in pixels
SPACESIZE = 0 # width & height of each space on the board, in pixels
BOARDWIDTH = 0 # how many columns of spaces on the game board
BOARDHEIGHT = 0 # how many rows of spaces on the game board
# Amount of space on the left & right side (XMARGIN) or above and below
# (YMARGIN) the game board, in pixels.


XMARGIN = 50 #int((WINDOWWIDTH - (BOARDWIDTH * SPACESIZE)) / 2)
YMARGIN = 50 #int((WINDOWHEIGHT - (BOARDHEIGHT * SPACESIZE)) / 2)

sBackgroundImage = 'PSU_MAIN.png'
sZero1_normal ='PSU_ZERO1_normal.png'
sZero1_ON = 'PSU_ZERO1_ON.png'
sZero1_red = 'PSU_ZERO1_red.png'

sZero2_normal ='PSU_ZERO2_normal.png'
sZero2_ON = 'PSU_ZERO2_ON.png'
sZero2_red = 'PSU_ZERO2_red.png'

		

# colors defines
#              R    G    B
WHITE      = (255, 255, 255)
BLACK      = (  0,   0,   0)
GREEN      = (  0, 155,   0)
BRIGHTBLUE = (  0,  50, 255)
BROWN      = (174,  94,   0)
CYAN       = (202,  253,  255 )
BOX_BACKCOLOR = (192,  192,  255 )
RED	= (255,0,0)

TEXTCOLOR = WHITE
TEXTBGCOLOR3 = CYAN
TEXTCOLOR_BLACK = BLACK
TEXTCOLOR_RED = RED

byteread = bytearray()

port_file = "portfile"

remotesend=""

sI1read=""
sI2read=""
U1State=0
U2State=0
sU1read=""
sU2read=""




def main():
    global DISPLAYSURF,TEXT_MENU_FONT,SMALLFONT, bytearray, byteread,U1setting,U2setting,I1setting,I2setting,IPsetting
    global dev,sIP,sPORT,remotesend,remoteanswer
    global sI1read,sI2read,U1State,U2State,sU1read,sU2read

    sU1read =""
    
    count = 0
    
    sinputkey =""
    Oldsinputkey ="xx"
    keypressed =0
    U1setting =0
    I1setting =0
    U2setting =0
    I2setting =0

    U1State =0
    U2State =0
    
    Trackingtate=1
    
    IPsetting =0
    PORTsetting=0

    b = bytearray()

    sPORT = "1236"

    if os.path.exists(port_file) :
	Config_file = open (port_file,'r')
        Config_line_list = Config_file.readlines()    
        Config_file.close()
	sPORT = Config_line_list[0].replace("\n","").replace("\r","")

    print sPORT
 
    Mouse_x=0
    Mouse_y=0
    Mouse_click=1;
 
    remotesend=""
   
    pygame.init()

    # create and run thread socket to dialog with android modile
    thread_1 = REMOTE_socket_for_server("")
    thread_1.start()


    #for fontname in pygame.font.get_fonts():
    #    print fontname

    try :
	dev = usb.core.find(idVendor=0x04d8, idProduct=0x01ff) 
  
	if dev.is_kernel_driver_active(0) is True :
        	dev.detach_kernel_driver(0)
	if dev is None:
        	raise ValueError('Device not found')
		print "Device not found"
  
	dev.set_configuration()	
    except Exception, e:
	print "retry start" + str(e)	

    print "init" 
    screen = pygame.display.get_surface()

    # Set up the background image.
    boardImage = pygame.image.load(sBackgroundImage)
    print boardImage.get_rect().size # 959 453
    DISPLAYSURF = pygame.display.set_mode(boardImage.get_rect().size,pygame.RESIZABLE)
    infoObject = pygame.display.Info()
    pygame.display.set_caption(version)

 
    # Set up the background image.
    boardImage = pygame.image.load(sBackgroundImage)
    boardImageRect = boardImage.get_rect()
    DISPLAYSURF.blit(boardImage, boardImageRect)

    TEXT_MENU_FONT = pygame.font.SysFont("freemono", 26)
    TEXT_MENU_FONT.set_bold(True)
    SMALLFONT = pygame.font.Font('freesansbold.ttf', 14)
  #  TEXT_MENU_FONT = pygame.font.SysFont("freeserif", 26)
    Mouse_x, Mouse_y = pygame.mouse.get_pos()

    Zero1_normal = pygame.image.load(sZero1_normal)
    DISPLAYSURF.blit(Zero1_normal,(495 ,363))
    pygame.display.update()
    Zero2_normal = pygame.image.load(sZero2_normal)
    DISPLAYSURF.blit(Zero2_normal,(649 ,363))
    pygame.display.update()
	    
    Display_U1Read ("--.---")
    Display_U1Set ("--.---")

    Display_I1Read ("-.---")
    Display_I1Set ("-.---")
    
    Display_U2Read ("--.---")
    Display_U2Set ("--.---")

    Display_I2Read ("-.---")
    Display_I2Set ("-.---")
    
    Display_PORTSet(sPORT)
    

    while count < 2 :
	count -=1
	
	
	input = ''
	for event in pygame.event.get():
	    if event.type == pygame.QUIT:
		os.system("pkill -9 -f ps.py")
	    if event.type == pygame.KEYDOWN and keypressed==0:
		keypressed=1
		print event.key 
		if event.key == K_KP0 or event.key == K_0:
		    input = input + "0"
		if event.key == K_KP1 or event.key == K_1:
		    input = input + "1"
		if event.key == K_KP2 or event.key == K_2:
		    input = input + "2"
		if event.key == K_KP3 or event.key == K_3:
		    input = input + "3"
		if event.key == K_KP4 or event.key == K_4:
		    input = input + "4"
		if event.key == K_KP5 or event.key == K_5:
		    input = input + "5"
		if event.key == K_KP6 or event.key == K_6:
		    input = input + "6"
		if event.key == K_KP7 or event.key == K_7:
		    input = input + "7"
		if event.key == K_KP8 or event.key == K_8:
		    input = input + "8"
		if event.key == K_KP9 or event.key == K_9:
		    input = input + "9"
		if event.key == K_KP_PERIOD or event.key == 46:
		    input = input + "."
		if event.key == K_BACKSPACE:
		    sinputkey = sinputkey[:-1]
		else:
		    sinputkey = sinputkey + input
	    if event.type == pygame.KEYUP and keypressed==1:
		    keypressed=0


	# handle MOUSEBUTTONUP
	if event.type == pygame.MOUSEBUTTONDOWN and Mouse_click==1: # mouse bouton pressed
	      Mouse_x, Mouse_y = pygame.mouse.get_pos()
	      print Mouse_x, Mouse_y
	      Mouse_click=0
	if event.type == pygame.MOUSEBUTTONUP : # mouse bouton released
	      Mouse_click=1	      
	
	###############################
	# check USet output #1 request
	###############################
	if Mouse_x > 100 and Mouse_x < 220 and Mouse_y> 150 and Mouse_y < 180 and (U1setting==0 or sinputkey=="xx.xxx"):
		sinputkey=""
		Display_U1Set ("      ")

	if Mouse_x > 100 and Mouse_x < 220 and Mouse_y> 150 and Mouse_y < 180:
		U1setting=1
		sinputkey = sinputkey[0:6]
		if sinputkey != Oldsinputkey :
		    Display_U1Set ("      ")
		    Oldsinputkey = sinputkey
		Display_U1Set (sinputkey)

	###############################
	# check ISet output #1 request
	###############################
	if Mouse_x > 300 and Mouse_x < 430 and Mouse_y> 150 and Mouse_y < 180 and (I1setting==0 or sinputkey=="x.xxx"):
		sinputkey=""
		Display_I1Set ("     ")

	if Mouse_x > 300 and Mouse_x < 430 and Mouse_y> 150 and Mouse_y < 180:
		I1setting=1
		sinputkey = sinputkey[0:5]
		if sinputkey != Oldsinputkey :
		    Display_I1Set ("     ")
		    Oldsinputkey = sinputkey
		Display_I1Set (sinputkey)

	###############################
	# check ISet output #2 request
	###############################
	if Mouse_x > 775 and Mouse_x < 890 and Mouse_y> 150 and Mouse_y < 180 and (I2setting==0 or sinputkey=="x.xxx"):
		sinputkey=""
		Display_I2Set ("     ")

	if Mouse_x > 775 and Mouse_x < 890 and Mouse_y> 150 and Mouse_y < 180:
		I2setting=1
		sinputkey = sinputkey[0:5]
		if sinputkey != Oldsinputkey :
		    Display_I2Set ("     ")
		    Oldsinputkey = sinputkey
		Display_I2Set (sinputkey)
		
	###############################
	# check USet output #2 request
	###############################
	if Mouse_x > 562 and Mouse_x < 680 and Mouse_y> 150 and Mouse_y < 180 and (U2setting==0 or sinputkey=="xx.xxx"):
		sinputkey=""
		Display_U2Set ("      ")

	if Mouse_x > 562 and Mouse_x < 680 and Mouse_y> 150 and Mouse_y < 180:
		U2setting=1
		sinputkey = sinputkey[0:6]
		if sinputkey != Oldsinputkey :
		    Display_U2Set ("      ")
		    Oldsinputkey = sinputkey
		Display_U2Set (sinputkey)

		
	################################
	# check Apply button output #1
	################################
	if Mouse_x > 310 and Mouse_x < 430 and Mouse_y> 200 and Mouse_y < 230:
		if U1setting==1:	# apply U1 set ?
		    # check if value valid
		    if len(sinputkey) < 6 or sinputkey[0] < '0' or sinputkey[0] > '9' or sinputkey[1] < '0' or sinputkey[1] > '9' or sinputkey[3] < '0' or sinputkey[3] > '9' or sinputkey[4] < '0' or sinputkey[4] > '9' or sinputkey[5] < '0' or sinputkey[5] > '9' or sinputkey[2] != '.' :
			U1setting=1
			sinputkey="xx.xxx"
			Display_U1Set (sinputkey)			
		    else :
			sinputkey = sinputkey[0:6]
			sinputkey = sinputkey.replace(".", "")
			b = "\1" + sinputkey # SET_U1_VOLTAGE = 0x01
			USB_Send_Cmd (b)
			U1setting=0

		if I1setting==1:	# apply I1 set ?
		    # check if value valid
		    if len(sinputkey) < 5 or sinputkey[0] < '0' or sinputkey[0] > '9' or sinputkey[2] < '0' or sinputkey[2] > '9' or sinputkey[3] < '0' or sinputkey[3] > '9' or sinputkey[4] < '0' or sinputkey[4] > '9' or sinputkey[1] != '.' :
			I1setting=1
			print sinputkey
			sinputkey="x.xxx"
			Display_I1Set (sinputkey)			
		    else :
			sinputkey = sinputkey[0:5]
			sinputkey = sinputkey.replace(".", "")
			b = chr(2) + "0" + sinputkey # SET_I1_LIMIT = 0x02
			USB_Send_Cmd (b)
			I1setting=0			
		Mouse_x=0
		Mouse_y=0

	################################
	# check Apply button output #2
	################################
	if Mouse_x > 770 and Mouse_x < 890 and Mouse_y> 200 and Mouse_y < 230:
		if U2setting==1:	# apply U2 set ?
		    # check if value valid
		    if len(sinputkey) < 6 or sinputkey[0] < '0' or sinputkey[0] > '9' or sinputkey[1] < '0' or sinputkey[1] > '9' or sinputkey[3] < '0' or sinputkey[3] > '9' or sinputkey[4] < '0' or sinputkey[4] > '9' or sinputkey[5] < '0' or sinputkey[5] > '9' or sinputkey[2] != '.' :
			U2setting=1
			sinputkey="xx.xxx"
			Display_U2Set (sinputkey)			
		    else :
			sinputkey = sinputkey[0:6]
			sinputkey = sinputkey.replace(".", "")
			b = "\3" + sinputkey # SET_U2_VOLTAGE = 0x03
			USB_Send_Cmd (b)
			U2setting=0
		if I2setting==1: 	# apply I2 set ?
		    # check if value valid
		    if len(sinputkey) < 5 or sinputkey[0] < '0' or sinputkey[0] > '9' or sinputkey[2] < '0' or sinputkey[2] > '9' or sinputkey[3] < '0' or sinputkey[3] > '9' or sinputkey[4] < '0' or sinputkey[4] > '9' or sinputkey[1] != '.' :
			I2setting=1
			sinputkey="x.xxx"
			Display_I2Set (sinputkey)			
		    else :
			sinputkey = sinputkey[0:6]
			sinputkey = sinputkey.replace(".", "")
			b = chr(4) + "0" + sinputkey # SET_I2_LIMIT = 0x04
			USB_Send_Cmd (b)
			I2setting=0			
		Mouse_x=0
		Mouse_y=0

		    
	################################
	# check ON/OFF button output #1
	################################
	if Mouse_x > 100 and Mouse_x < 190 and Mouse_y> 260 and Mouse_y < 290:
		if U1State == 0 :
			b = "\5" # SET_U1_ON = 0x05;
			print "ON/OFF set 1"
		else :
			b = "\6" # SET_U1_OFF = 0x06;
			print "ON/OFF set 0"
		USB_Send_Cmd (b) 

		Mouse_x=0
		Mouse_y=0


	################################
	# check ON/OFF button output 2 #
	################################
	if Mouse_x > 565 and Mouse_x < 650 and Mouse_y> 260 and Mouse_y < 290:
		print "ON/OFF button 2"	    
		if U2State == 0 :
			b = "\7" # SET_U2_ON = 0x07;
			print "ON/OFF set 1"
		else :
			b = [0x08] # SET_U2_OFF = 0x08;
			print "ON/OFF set 0"
		USB_Send_Cmd (b) 
		Mouse_x=0
		Mouse_y=0

	###########################
	# check TRACKING button   #
	###########################
	if Mouse_x > 800 and Mouse_x < 890 and Mouse_y> 365 and Mouse_y < 400:
		print "Tracking button2"	    
		if Trackingtate == 0 :
			b = [0x0b] # SET_VOLTAGE_TRACKING_ON  = 0x0B
			print "TRACKING ON"
		else :
			b = [0x0c] # SET_VOLTAGE_TRACKING_OFF = 0x0C
			print "TRACKING OFF"
		USB_Send_Cmd (b) 
		Mouse_x=0
		Mouse_y=0

	################################
	# check ZERO button output #1
	################################
	if Mouse_x > 500 and Mouse_x < 630 and Mouse_y> 350 and Mouse_y < 395:
	    
	    ZERO_I1 ()
	    Mouse_x=0
	    Mouse_y=0

	################################
	# check ZERO button output #2
	################################
	if Mouse_x > 650 and Mouse_x < 785 and Mouse_y> 350 and Mouse_y < 395:
	    
	    ZERO_I2 ()
	    Mouse_x=0
	    Mouse_y=0

		
	###############################
	# check PORT setting request
	###############################
	if Mouse_x > 160 and Mouse_x < 280 and Mouse_y> 370 and Mouse_y < 390 and (PORTsetting==0 or sinputkey=="xx.xxx"):
		sinputkey=""
		Display_PORTSet ("      ")

	if Mouse_x > 160 and Mouse_x < 280 and Mouse_y> 370 and Mouse_y < 390 :
		PORTsetting=1
		#sinputkey = sinputkey[0:6]
		if sinputkey != Oldsinputkey :
		    Display_PORTSet ("                 ")
		    Oldsinputkey = sinputkey
		Display_PORTSet (sinputkey)
		sPORT = sinputkey
                os.system("echo %s > %s" % (sPORT,port_file)) # record sPORT


	if  (1==1):



	    ################################
	    # Get and display U1 read
	    ################################
	    USB_Send_Cmd ([0x51]) # READ_U1_VOLTAGE = 0x51;
	    sU1read = " ".join(chr(byteread[1])) + " ".join(chr(byteread[2])) + '.' + " ".join(chr(byteread[3])) + " ".join(chr(byteread[4])) + " ".join(chr(byteread[5]))
	    Display_U1Read (sU1read)

	    ################################
	    # Get and display I1 read
	    ################################
	    USB_Send_Cmd ([0x53])  # READ_I1_CURRENT = 0x53;
	    sI1read = " ".join(chr(byteread[2])) + '.' + " ".join(chr(byteread[3])) + " ".join(chr(byteread[4])) + " ".join(chr(byteread[5]))
	    if sI1read.find(":.:::") != -1 :
		sI1read="-.---"
			
	    Display_I1Read (sI1read)

	    ################################
	    # Get and display U1 Set
	    ################################
	    if U1setting ==0:
	        USB_Send_Cmd ([0x52])  # READ_U1_SET     = 0x52;
	        sU1set = " ".join(chr(byteread[1])) + " ".join(chr(byteread[2])) + '.' + " ".join(chr(byteread[3])) + " ".join(chr(byteread[4])) + " ".join(chr(byteread[5]))
		Display_U1Set (sU1set)

	    ################################
	    # Get and display I1 Set
	    ################################
	    if I1setting ==0:
	        USB_Send_Cmd ([0x54])   # READ_I1_LIMIT   = 0x54;
	        sI1set = " ".join(chr(byteread[2])) + '.' + " ".join(chr(byteread[3])) + " ".join(chr(byteread[4])) + " ".join(chr(byteread[5]))
		Display_I1Set (sI1set)
		
	    #################################
	    # udpate U1 state ON/OFF
	    ################################
            USB_Send_Cmd ([0x59])   #  READ_U1_STATE   = 0x59;
	    if (byteread[1] ==1) :
		    pygame.draw.rect(DISPLAYSURF, GREEN, (203, 269, 16, 14))
		    U1State =1
	    else :
		    pygame.draw.rect(DISPLAYSURF, RED, (203, 269, 16, 14))
		    U1State =0

	    

	    ################################
	    # Get and display U2 read
	    ################################
	    USB_Send_Cmd ([0x55])  # READ_U2_VOLTAGE = 0x55;
	    sU2read = " ".join(chr(byteread[1])) + " ".join(chr(byteread[2])) + '.' + " ".join(chr(byteread[3])) + " ".join(chr(byteread[4])) + " ".join(chr(byteread[5]))
	    Display_U2Read (sU2read)


	    ################################
	    # Get and display I2 read
	    ################################
	    USB_Send_Cmd ([0x57])  # READ_I2_CURRENT = 0x57;
	    sI2read = " ".join(chr(byteread[2])) + '.' + " ".join(chr(byteread[3])) + " ".join(chr(byteread[4])) + " ".join(chr(byteread[5]))
	    if sI2read.find(":.:::") != -1 :
		sI2read="-.---"
	    Display_I2Read (sI2read)

	    ################################
	    # Get and display U2 Set
	    ################################
	    if U2setting ==0:
	        USB_Send_Cmd ([0x56])   # READ_U2_SET     = 0x56;
	        sU2set = " ".join(chr(byteread[1])) + " ".join(chr(byteread[2])) + '.' + " ".join(chr(byteread[3])) + " ".join(chr(byteread[4])) + " ".join(chr(byteread[5]))

		Display_U2Set (sU2set)

	    ################################
	    # Get and display I2 Set
	    ################################
	    if I2setting ==0:
	        USB_Send_Cmd ([0x58])   # READ_I2_LIMIT   = 0x58;
	        sI2set = " ".join(chr(byteread[2])) + '.' + " ".join(chr(byteread[3])) + " ".join(chr(byteread[4])) + " ".join(chr(byteread[5]))
		Display_I2Set (sI2set)

	    #################################
	    # udpate U2 state ON/OFF
	    ################################
            USB_Send_Cmd ([0x5A])   # READ_U2_STATE   = 0x5A
	    if (byteread[1] ==1) :
		    pygame.draw.rect(DISPLAYSURF, GREEN, (668, 269, 16, 14))
		    U2State =1
	    else :
		    pygame.draw.rect(DISPLAYSURF, RED, (668, 269, 16, 14))
		    U2State =0
		    
	    ################################
	    # udpate TRACKING state ON/OFF
	    ################################
            USB_Send_Cmd ([0x5D])   # READ_TRACKING_STATE = 0x5D
	    if (byteread[1] ==1) :
		    pygame.draw.rect(DISPLAYSURF, GREEN, (904, 375, 16, 14))
		    Trackingtate =1
	    else :
		    pygame.draw.rect(DISPLAYSURF, RED, (904, 375, 16, 14))
		    Trackingtate =0

	    ################################
	    # udpate REMOTE state ON/OFF
	    ################################
	    if receiving ==1 :
		    pygame.draw.rect(DISPLAYSURF, GREEN, (317, 375, 16, 14))
            else :
		    pygame.draw.rect(DISPLAYSURF, RED, (317, 375, 16, 14))
	    pygame.display.update()

	    ##################
	    # Display Powers #
	    ##################
	    try :
 	    	Display_U1Power(float(sI1read)*float(sU1read))
	    	Display_U2Power(float(sI2read)*float(sU2read))
	    except Exception, e:
	        print "retry power" + str(e)
		    
	    #################################
	    # get data for remote request
	    ################################
	    if len(remoteanswer) != 0 :
	    
		if remoteanswer.find("READ_U1_VOLTAGE") != -1 :
		    remotesend = "READ_U1_VOLTAGE"+sU1read + "\n"

		if remoteanswer.find("READ_U2_VOLTAGE") != -1 :
		    remotesend = "READ_U2_VOLTAGE"+sU2read + "\n"
     
		if remoteanswer.find("READ_U1_SET") != -1 :
		    remotesend = "READ_U1_SET"+sU1set + "\n"

		if remoteanswer.find("READ_U2_SET") != -1 :
		    remotesend = "READ_U2_SET"+sU2set + "\n"

		if remoteanswer.find("READ_I1_CURRENT") != -1 :
		    remotesend = "READ_I1_CURRENT"+sI1read + "\n"

		if remoteanswer.find("READ_I2_CURRENT") != -1 :
		    remotesend = "READ_I2_CURRENT"+sI2read + "\n"

		if remoteanswer.find("READ_I1_LIMIT") != -1 :
		    remotesend = "READ_I1_LIMIT"+sI1set + "\n"

		if remoteanswer.find("READ_I2_LIMIT") != -1 :
		    remotesend = "READ_I2_LIMIT"+sI2set + "\n"

		if remoteanswer.find("READ_U1_STATE") != -1 :
		    remotesend = "READ_U1_STATE"+chr(U1State) + "\n"

		if remoteanswer.find("READ_U2_STATE") != -1 :
		    remotesend = "READ_U2_STATE"+chr(U2State) + "\n"
		    
		if remoteanswer.find("READ_TRACKING_STATE") != -1 :
		    remotesend = "READ_TRACKING_STATE"+chr(Trackingtate) + "\n"
		    
		if remoteanswer.find("SET_U1_VOLTAGE") != -1 :
		    remoteanswer = remoteanswer.replace("SET_U1_VOLTAGE", "")
		    remoteanswer = re.sub("[ .,]",'',remoteanswer)
		    b = "\1" + remoteanswer # SET_U1_VOLTAGE = 0x01
		    USB_Send_Cmd (b)
		    remotesend = "OK" + "\n"
		    
		if remoteanswer.find("SET_U2_VOLTAGE") != -1 :
		    remoteanswer = remoteanswer.replace("SET_U2_VOLTAGE", "")
		    remoteanswer = re.sub("[ .,]",'',remoteanswer)
		    b = "\3" + remoteanswer # SET_U2_VOLTAGE = 0x03
		    USB_Send_Cmd (b)		    
		    remotesend = "OK" + "\n"

		if remoteanswer.find("SET_I1_LIMIT") != -1 :
		    remoteanswer = remoteanswer.replace("SET_I1_LIMIT", "")
		    remoteanswer = re.sub("[ .,]",'',remoteanswer)
		    b = chr(2)  + remoteanswer # SET_I1_LIMIT = 0x02
		    USB_Send_Cmd (b)		    
		    remotesend = "OK" + "\n"
		    
		if remoteanswer.find("SET_I2_LIMIT") != -1 :
		    remoteanswer = remoteanswer.replace("SET_I2_LIMIT", "")
		    remoteanswer = re.sub("[ .,]",'',remoteanswer)
		    b = chr(4) + remoteanswer # SET_I2_LIMIT = 0x04
		    USB_Send_Cmd (b)		    
		    remotesend = "OK" + "\n"

		if remoteanswer.find("SET_U1_ON") != -1 :
		    b = chr(5) + "00000000000" + remoteanswer # SET_U1_ON = 0x05
		    USB_Send_Cmd (b)
		    remotesend = "OK" + "\n"		    

		if remoteanswer.find("SET_U2_ON") != -1 :
		    b = chr(7) + "00000000000" + remoteanswer # SET_U2_ON = 0x07
		    USB_Send_Cmd (b)		    
		    remotesend = "OK" + "\n"

		if remoteanswer.find("SET_U1_OFF") != -1 :
		    b = chr(6) + "00000000000" + remoteanswer # SET_U1_OFF = 0x06
		    USB_Send_Cmd (b)		    
		    remotesend = "OK" + "\n"
		    
		if remoteanswer.find("SET_U2_OFF") != -1 :
		    b = chr(8) + "00000000000" + remoteanswer # SET_U2_OFF = 0x08
		    USB_Send_Cmd (b)		    
		    remotesend = "OK" + "\n"
		    
		if remoteanswer.find("SET_VOLTAGE_TRACKING_ON") != -1 :
		    b = [0x0b] # SET_VOLTAGE_TRACKING_ON  = 0x0B
		    USB_Send_Cmd (b)		    
		    remotesend = "OK" + "\n"
		    
		if remoteanswer.find("SET_VOLTAGE_TRACKING_OFF") != -1 :
		    b = [0x0c] # SET_VOLTAGE_TRACKING_OFF = 0x0C
		    USB_Send_Cmd (b)		    
		    remotesend = "OK" + "\n"
		    
		if remoteanswer.find("SET_VOLTAGE_TRACKING_OFF") != -1 :
		    b = [0x0c] # SET_VOLTAGE_TRACKING_OFF = 0x0C
		    USB_Send_Cmd (b)		    
		    remotesend = "OK" + "\n"
		
		if remoteanswer.find("ZERO_1") != -1 :    
		    ZERO_I1 ()
		    remotesend = "OK" + "\n"
		    
		if remoteanswer.find("ZERO_2") != -1 :    
		    ZERO_I2 ()
		    remotesend = "OK" + "\n"		    
		
	pygame.display.update()

	
  #  print ret
 
 
##########################
#  ZERO CURRENT OUTPUT 1 #
##########################
def ZERO_I1 () :
    
    Zero1_ON = pygame.image.load(sZero1_ON)
    DISPLAYSURF.blit(Zero1_ON,(496 ,364))
    pygame.display.update()

    USB_Send_Cmd ([0x0A]) # SET_CURRENT_LIMIT_OFF = 0x0A
    time.sleep(0.1)
    USB_Send_Cmd ([0x06]) # SET_U1_OFF = 0x06

    USB_Send_Cmd ([0x8F]) # READ_I1_READ_CAL_DIV = 0x8E
    TEST = byteread[1] + byteread[2]*256
    print "OFFSET",TEST

    # record calibration
    USB_Send_Cmd ([0x8E]) # READ_I1_READ_CAL_DIV = 0x8E
    READ_I1_READ_CAL_DIV = byteread[1] + byteread[2]*256
    print "READ_I1_READ_CAL_DIV",READ_I1_READ_CAL_DIV

    USB_Send_Cmd ([0x8C]) # READ_I1_READ_CAL_MUL = 0x8C
    READ_I1_READ_CAL_MUL = byteread[1] + byteread[2]*256
    print "READ_I1_READ_CAL_MUL",READ_I1_READ_CAL_MUL

    USB_Send_Cmd ([0x2D,232,3]) # SET_I1_READ_CAL_MUL  = 0x2D = 1000
    USB_Send_Cmd ([0x2E,232,3]) # SET_I1_READ_CAL_DIV  = 0x2E = 1000
    USB_Send_Cmd ([0x2F,0,0])   # SET_I1_READ_CAL_OFS  = 0x2F = 0000
	    
    # set voltage to 1V
    USB_Send_Cmd (chr(1) + "01000")
    time.sleep(2)

    USB_Send_Cmd ([0x53]) # READ_I1_CURRENT = 0x53
    time.sleep(1)
    USB_Send_Cmd ([0x53]) # READ_I1_CURRENT = 0x53
    time.sleep(1)
    USB_Send_Cmd ([0x53]) # READ_I1_CURRENT = 0x53
    time.sleep(1)


    I1READLOW = (byteread[2]-0x30)*1000 + (byteread[3]-0x30)*100 + (byteread[4]-0x30)*10 + byteread[5]-0x30
    sI1read = " ".join(chr(byteread[2])) + '.' + " ".join(chr(byteread[3])) + " ".join(chr(byteread[4])) + " ".join(chr(byteread[5]))
    print sI1read
    print "I1READLOW" ,I1READLOW 

    IREADLOW_MSB = I1READLOW /256
    print "IREADLOW_MSB" ,IREADLOW_MSB
    IREADLOW_LSB = I1READLOW - IREADLOW_MSB*256
    print "IREADLOW_LSB" ,IREADLOW_LSB

    USB_Send_Cmd ([0x2F,IREADLOW_LSB,IREADLOW_MSB])   # SET_I1_READ_CAL_OFS  = 0x2F = I1READLOW

    #restore calibration values
    print "READ_I1_READ_CAL_DIV",READ_I1_READ_CAL_DIV
    READ_I1_READ_CAL_DIV_MSB = READ_I1_READ_CAL_DIV /256
    print "READ_I1_READ_CAL_DIV_MSB",READ_I1_READ_CAL_DIV_MSB
    READ_I1_READ_CAL_DIV_LSB = READ_I1_READ_CAL_DIV - READ_I1_READ_CAL_DIV_MSB*256
    print "READ_I1_READ_CAL_DIV_LSB",READ_I1_READ_CAL_DIV_LSB
    
    USB_Send_Cmd ([0x2E,READ_I1_READ_CAL_DIV_LSB,READ_I1_READ_CAL_DIV_MSB]) # SET_I1_READ_CAL_DIV  = 0x2E = READ_I1_READ_CAL_DIV

    READ_I1_READ_CAL_MUL_MSB = READ_I1_READ_CAL_MUL/256
    READ_I1_READ_CAL_MUL_LSB = READ_I1_READ_CAL_MUL - READ_I1_READ_CAL_MUL_MSB*256
    print "READ_I1_READ_CAL_MUL_MSB",READ_I1_READ_CAL_MUL_MSB
    print "READ_I1_READ_CAL_MUL_LSB",READ_I1_READ_CAL_MUL_LSB

    USB_Send_Cmd ([0x2D,READ_I1_READ_CAL_MUL_LSB,READ_I1_READ_CAL_MUL_MSB]) # SET_I1_READ_CAL_MUL  = 0x2D = READ_I1_READ_CAL_MUL

    USB_Send_Cmd ([0x09]) # SET_CURRENT_LIMIT_ON = 0x09
    USB_Send_Cmd ([0x05]) # SET_U1_ON = 0x05;

    Zero1_normal = pygame.image.load(sZero1_normal)
    DISPLAYSURF.blit(Zero1_normal,(495 ,363))
    pygame.display.update()  
  
##########################
#  ZERO CURRENT OUTPUT 2 #
##########################
def ZERO_I2 () :
    
    Zero2_ON = pygame.image.load(sZero2_ON)
    DISPLAYSURF.blit(Zero2_ON,(649 ,364))
    pygame.display.update()

    USB_Send_Cmd ([0x0A]) # SET_CURRENT_LIMIT_OFF = 0x0A
    time.sleep(0.1)
    USB_Send_Cmd ([0x08]) # SET_U2_OFF = 0x08

    # record calibration
    USB_Send_Cmd ([0x91]) # READ_I2_READ_CAL_DIV = 0x91
    READ_I2_READ_CAL_DIV = byteread[1] + byteread[2]*256
    print "READ_I2_READ_CAL_DIV",READ_I2_READ_CAL_DIV

    USB_Send_Cmd ([0x90]) # READ_I2_READ_CAL_MUL = 0x90
    READ_I2_READ_CAL_MUL = byteread[1] + byteread[2]*256
    print "READ_I2_READ_CAL_MUL",READ_I2_READ_CAL_MUL
    
    USB_Send_Cmd ([0x30,232,3]) # SET_I2_READ_CAL_MUL  = 0x30 = 1000
    USB_Send_Cmd ([0x31,232,3]) # SET_I2_READ_CAL_DIV  = 0x31 = 1000
    USB_Send_Cmd ([0x32,0,0])   # SET_I2_READ_CAL_OFS  = 0x32 = 0000

    # set voltage to 1V
    USB_Send_Cmd (chr(3) + "01000")

    time.sleep(2)

    USB_Send_Cmd ([0x57]) # READ_I2_CURRENT = 0x57
    time.sleep(1)
    USB_Send_Cmd ([0x57]) # READ_I2_CURRENT = 0x57
    time.sleep(1)
    USB_Send_Cmd ([0x57]) # READ_I2_CURRENT = 0x57
    time.sleep(1)

    I2READLOW = (byteread[2]-0x30)*1000 + (byteread[3]-0x30)*100 + (byteread[4]-0x30)*10 + byteread[5]-0x30
    sI2read = " ".join(chr(byteread[2])) + '.' + " ".join(chr(byteread[3])) + " ".join(chr(byteread[4])) + " ".join(chr(byteread[5]))
    print sI2read
    print "I2READLOW" ,I2READLOW
    IREADLOW_MSB = I2READLOW /256
    print "IREADLOW_MSB" ,IREADLOW_MSB
    IREADLOW_LSB = I2READLOW - IREADLOW_MSB*256
    print "IREADLOW_LSB" ,IREADLOW_LSB
  
    USB_Send_Cmd ([0x32,IREADLOW_LSB,IREADLOW_MSB])   # SET_I2_READ_CAL_OFS  = 0x32 = I2READLOW

    #restore calibration values
    READ_I2_READ_CAL_DIV_MSB = READ_I2_READ_CAL_DIV /256
    print "READ_I2_READ_CAL_DIV_MSB",READ_I2_READ_CAL_DIV_MSB
    READ_I2_READ_CAL_DIV_LSB = READ_I2_READ_CAL_DIV - READ_I2_READ_CAL_DIV_MSB*256
    print "READ_I2_READ_CAL_DIV_LSB",READ_I2_READ_CAL_DIV_LSB
    USB_Send_Cmd ([0x31,READ_I2_READ_CAL_DIV_LSB,READ_I2_READ_CAL_DIV_MSB]) # SET_I2_READ_CAL_DIV  = 0x31 = READ_I2_READ_CAL_DIV

    READ_I2_READ_CAL_MUL_MSB = READ_I2_READ_CAL_MUL/256
    READ_I2_READ_CAL_MUL_LSB = READ_I2_READ_CAL_MUL - READ_I2_READ_CAL_MUL_MSB*256
    USB_Send_Cmd ([0x30,READ_I2_READ_CAL_MUL_LSB,READ_I2_READ_CAL_MUL_MSB]) # SET_I2_READ_CAL_MUL  = 0x2D = READ_I2_READ_CAL_MUL

    USB_Send_Cmd ([0x09]) # SET_CURRENT_LIMIT_ON = 0x09
    USB_Send_Cmd ([0x07]) # SET_U2_ON = 0x07;

    Zero2_normal = pygame.image.load(sZero2_normal)
    DISPLAYSURF.blit(Zero2_normal,(649 ,363))
    pygame.display.update()

#####################
#  Display U1 Power #
#####################
def Display_U1Power (value) :
	try :
	    U1Powertext = TEXT_MENU_FONT.render('{:06.3f}'.format(float(value)), True, TEXTCOLOR_BLACK,BOX_BACKCOLOR)
	    if U1State == 0 :
		U1Powertext = TEXT_MENU_FONT.render("--.---", True, TEXTCOLOR_BLACK,BOX_BACKCOLOR)		
	    U1PowerRect = U1Powertext.get_rect()
	    U1PowerRect.topleft = (105,205)
	    DISPLAYSURF.blit(U1Powertext, U1PowerRect)
	    pygame.display.update()
	except Exception, e:
	    print "retry display U1 Power" + str(e)
	
#####################
#  Display U2 Power #
#####################
def Display_U2Power (value) :

	try :
	    U2Powertext = TEXT_MENU_FONT.render('{:06.3f}'.format(float(value)), True, TEXTCOLOR_BLACK,BOX_BACKCOLOR)
	    if U2State == 0 :
		U2Powertext = TEXT_MENU_FONT.render("--.---", True, TEXTCOLOR_BLACK,BOX_BACKCOLOR)		
	    U2PowerRect = U2Powertext.get_rect()
	    U2PowerRect.topleft = (120+450,205)
	    DISPLAYSURF.blit(U2Powertext, U2PowerRect)
	    pygame.display.update()
	except Exception, e:
	    print "retry display U2 Power" + str(e)
  
#########################
#  Display U1Read value #
#########################
def Display_U1Read (value) :

	try :
	    U1Readtext = TEXT_MENU_FONT.render(value, True, TEXTCOLOR_BLACK,BOX_BACKCOLOR)
	    if U1State == 0 :
		U1Readtext = TEXT_MENU_FONT.render("--.---", True, TEXTCOLOR_BLACK,BOX_BACKCOLOR)		
	    U1ReadRect = U1Readtext.get_rect()
	    U1ReadRect.topleft = (105,97)
	    DISPLAYSURF.blit(U1Readtext, U1ReadRect)
	    pygame.display.update()
	except Exception, e:
	    print "retry display" + str(e)

#########################
#  Display U1Set value #
#########################
def Display_U1Set (value) :

    if U1setting ==0:
	sU1settext = TEXT_MENU_FONT.render(value, True, TEXTCOLOR_BLACK,BOX_BACKCOLOR)
    else :
	sU1settext = TEXT_MENU_FONT.render(value, True, GREEN,BOX_BACKCOLOR)
    sU1setRect = sU1settext.get_rect()
    sU1setRect.topleft = (105,150)
    DISPLAYSURF.blit(sU1settext, sU1setRect)
    pygame.display.update()
    
#########################
#  Display I1Read value #
#########################
def Display_I1Read (value) :
	try :
	    if sI1read.find("-.---") != -1 :
		    I1Readtext = TEXT_MENU_FONT.render(value, True, TEXTCOLOR_RED,BOX_BACKCOLOR)		
		    Zero1_normal = pygame.image.load(sZero1_red)
	    else :
		    I1Readtext = TEXT_MENU_FONT.render(value, True, TEXTCOLOR_BLACK,BOX_BACKCOLOR)		
		    Zero1_normal = pygame.image.load(sZero1_normal)
	
	    DISPLAYSURF.blit(Zero1_normal,(495 ,363))

	    if U1State == 0 :
		I1Readtext = TEXT_MENU_FONT.render("-.---", True, TEXTCOLOR_BLACK,BOX_BACKCOLOR)
	
	    I1ReadRect = I1Readtext.get_rect()
	    I1ReadRect.topleft = (327,97)
	    DISPLAYSURF.blit(I1Readtext, I1ReadRect)
	    pygame.display.update()  
	except Exception, e:
	    print "retry display" + str(e)

#########################
#  Display I1Set value #
#########################
def Display_I1Set (value) :
	try :
	    if I1setting ==0:
		I1Settext = TEXT_MENU_FONT.render(value, True, TEXTCOLOR_BLACK,BOX_BACKCOLOR)
	    else :
		I1Settext = TEXT_MENU_FONT.render(value, True, GREEN,BOX_BACKCOLOR)  
 
	    I1SetRect = I1Settext.get_rect()
	    I1SetRect.topleft = (327,150)
	    DISPLAYSURF.blit(I1Settext, I1SetRect)
	    pygame.display.update()    
	except Exception, e:
	    print "retry display" + str(e)
	    
#########################
#  Display U2Read value #
#########################
def Display_U2Read (value) :

 	try :
		U2Readtext = TEXT_MENU_FONT.render(value, True, TEXTCOLOR_BLACK,BOX_BACKCOLOR)		
	        if U2State == 0 :
			U2Readtext = TEXT_MENU_FONT.render("--.---", True, TEXTCOLOR_BLACK,BOX_BACKCOLOR)		
	    	U2ReadRect = U2Readtext.get_rect()
    		U2ReadRect.topleft = (120+450,97)
    		DISPLAYSURF.blit(U2Readtext, U2ReadRect)
    		pygame.display.update()
	except Exception, e:
	    print "retry display" + str(e)
	    
#########################
#  Display U2Set value #
#########################
def Display_U2Set (value) :

	try :
	    if U2setting ==0:
		sU2settext = TEXT_MENU_FONT.render(value, True, TEXTCOLOR_BLACK,BOX_BACKCOLOR)
	    else :
		sU2settext = TEXT_MENU_FONT.render(value, True, GREEN,BOX_BACKCOLOR)
	    sU2setRect = sU2settext.get_rect()
	    sU2setRect.topleft = (120+450,150)
	    DISPLAYSURF.blit(sU2settext, sU2setRect)
	    pygame.display.update()
	except Exception, e:
	    print "retry display" + str(e)
    
#########################
#  Display I2Read value #
#########################
def Display_I2Read (value) :
    
	try :
	    if sI2read.find("-.---") != -1 :
		    I2Readtext = TEXT_MENU_FONT.render(value, True, TEXTCOLOR_RED,BOX_BACKCOLOR)
		    Zero2_normal = pygame.image.load(sZero2_red)		
	    else :
		    I2Readtext = TEXT_MENU_FONT.render(value, True, TEXTCOLOR_BLACK,BOX_BACKCOLOR)
		    Zero2_normal = pygame.image.load(sZero2_normal)

	    DISPLAYSURF.blit(Zero2_normal,(649 ,363))

	    if U2State == 0 :
		I2Readtext = TEXT_MENU_FONT.render("-.---", True, TEXTCOLOR_BLACK,BOX_BACKCOLOR)

  	    I2ReadRect = I2Readtext.get_rect()
    	    I2ReadRect.topleft = (334+450,97)
	    DISPLAYSURF.blit(I2Readtext, I2ReadRect)
	    pygame.display.update()  
	except Exception, e:
	    print "retry display" + str(e)

#########################
#  Display I2Set value #
#########################
def Display_I2Set (value) :

	try :
	    if I2setting ==0:
		I2Settext = TEXT_MENU_FONT.render(value, True, TEXTCOLOR_BLACK,BOX_BACKCOLOR)
	    else :
		I2Settext = TEXT_MENU_FONT.render(value, True, GREEN,BOX_BACKCOLOR)      
	    I2SetRect = I2Settext.get_rect()
	    I2SetRect.topleft = (334+450,150)
	    DISPLAYSURF.blit(I2Settext, I2SetRect)
	    pygame.display.update() 		    
	except Exception, e:
	    print "retry display" + str(e)
	    
	    
#######################
#  Display Port value #
#######################
def Display_PORTSet (value) :
	try :
	    if IPsetting ==0:
		PORTSettext = SMALLFONT.render(value, True, TEXTCOLOR_BLACK,BOX_BACKCOLOR)
	    else :
		PORTSettext = SMALLFONT.render(value, True, GREEN,BOX_BACKCOLOR)      
	    PORTSetRect = PORTSettext.get_rect()
	    PORTSetRect.topleft = (210,373)
	    DISPLAYSURF.blit(PORTSettext, PORTSetRect)
	    pygame.display.update() 		    
	except Exception, e:
	    print "retry display" + str(e)
	    
#########################
#  send data USB #
#########################
def USB_Send_Cmd (cmd) :
    global byteread, dev
    
    try :

	reattach = False

        dev.write(1, cmd,1000) 
        byteread = dev.read(0x81,64,1000)
	#byteread = [0x31,0x2D,0x2D,0x2D,0x2D,0x2D]
	#byteread = [142, 232, 3, 48, 48, 48,12]
	#################################
	# udpate display with USB state
	################################
	USBSTATEtext = SMALLFONT.render("PSU connected           ", True, TEXTCOLOR_BLACK,WHITE)		
	USBSTATERect = USBSTATEtext.get_rect()
	USBSTATERect.topleft = (10,427)
	DISPLAYSURF.blit(USBSTATEtext, USBSTATERect)
	return
	    
    except Exception, e:
	print "retry connect" + str(e)
	time.sleep(0.1)

	try :
		dev = usb.core.find(idVendor=0x04d8, idProduct=0x01ff) 
 		if dev.is_kernel_driver_active(0) is True :
			reattach = True
	    		dev.detach_kernel_driver(0)
		if dev is None:
	    		raise ValueError('Device not found')
			print "Device not found"
		dev.set_configuration()
 
	except Exception, e:
		print "retry 2" + str(e)
		time.sleep(1)
		try :
			print " usb.util.dispose_resources(dev) + reset"
			usb.util.dispose_resources(dev)
			dev.reset()
		except Exception, e:
			print "retry 3 : " + str(e)

#	if reattach:
#	    dev.attach_kernel_driver(0)
#	    dev.reset()

	# udpate display with USB state
	USBSTATEtext = SMALLFONT.render("PSU not seen on USB        ", True,RED,WHITE)		
	USBSTATERect = USBSTATEtext.get_rect()
	USBSTATERect.topleft = (10,427)
	DISPLAYSURF.blit(USBSTATEtext, USBSTATERect)
	pygame.display.update()
	byteread = [0x31,0x2D,0x2D,0x2D,0x2D,0x2D]
	#byteread = [142, 232, 3, 48, 48, 48,12]

	time.sleep(0.01)
	


###################################################
#  PSU thread to get message from remote control  # 
###################################################
class REMOTE_socket_for_server(Thread):
    

    def __init__(self, mot):

	Thread.__init__(self)

    def run(self):
	global sIP,sPORT,remoteanswer, remotesend, receiving

	
	while True:
		remoteanswer =""
		print sPORT
		receiving =0
		print "START THREAD RECEIVED :"
	
		sock = socket.socket(socket.AF_INET,socket.SOCK_DGRAM) 
		sock.bind(("", int (sPORT)))
		sock.settimeout(2) 

		while True:
		    
			try :
			    remoteanswer, addr = sock.recvfrom(100) # buffer size is 1024 bytes
			    print "received message:", remoteanswer
			    if remoteanswer != "" :
				receiving = 1
	
			    while True:
				if len(remotesend) != 0 :
				    break
			    
			    sock.sendto(remotesend,addr)
			    remotesend=""
			except socket.timeout:
			    print("timeout")
			    receiving = 0
			
if __name__ == '__main__':
    main()
 
